---
title: Generator.prototype.return()
slug: Web/JavaScript/Reference/Global_Objects/Generator/return
tags:
  - ECMAScript 2015
  - Generator
  - JavaScript
  - Method
  - Prototype
  - Reference
---
<div>{{JSRef}}</div>

<p>The <strong><code>return()</code></strong> method returns the given value and finishes the generator.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>gen</var>.return(<var>value</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>value</var></code></dt>
 <dd>The value to return.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The value that is given as an argument.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_return">Using return()</h3>

<p>The following example shows a simple generator and the <code>return</code> method.</p>

<pre class="brush: js notranslate">function* gen() {
  yield 1;
  yield 2;
  yield 3;
}

const g = gen();

g.next();        // { value: 1, done: false }
g.return('foo'); // { value: "foo", done: true }
g.next();        // { value: undefined, done: true }
</pre>

<p>If <code>return(<var>value</var>)</code> is called on a generator that is already in "completed" state, the generator will remain in "completed" state.</p>

<p>If no argument is provided, the <code>value</code> property of returned object is the same as if <code>.next()</code>. If an argument is provided, it will be set to the value of the <code>value</code> property of the returned object.</p>

<pre class="brush: js notranslate">function* gen() {
  yield 1;
  yield 2;
  yield 3;
}

const g = gen();
g.next(); // { value: 1, done: false }
g.next(); // { value: 2, done: false }
g.next(); // { value: 3, done: false }
g.next(); // { value: undefined, done: true }
g.return(); // { value: undefined, done: true }
g.return(1); // { value: 1, done: true }
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-generator.prototype.return', 'Generator.prototype.return')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Generator.return")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Statements/function*", "function*")}}</li>
</ul>
